"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VoidAuth = exports.OAuth = exports.ApiKeyAuth = exports.HttpBearerAuth = exports.HttpBasicAuth = exports.ObjectSerializer = void 0;
__exportStar(require("./address.js"), exports);
__exportStar(require("./affiliation.js"), exports);
__exportStar(require("./affiliationType.js"), exports);
__exportStar(require("./affiliationWrite.js"), exports);
__exportStar(require("./affiliationWritePatch.js"), exports);
__exportStar(require("./consent.js"), exports);
__exportStar(require("./consentPurpose.js"), exports);
__exportStar(require("./consentWrite.js"), exports);
__exportStar(require("./consentWritePatch.js"), exports);
__exportStar(require("./country.js"), exports);
__exportStar(require("./countryWrite.js"), exports);
__exportStar(require("./countryWritePatch.js"), exports);
__exportStar(require("./errorCode.js"), exports);
__exportStar(require("./errorData.js"), exports);
__exportStar(require("./errorDetails.js"), exports);
__exportStar(require("./gender.js"), exports);
__exportStar(require("./maritalStatus.js"), exports);
__exportStar(require("./metadata.js"), exports);
__exportStar(require("./nationalId.js"), exports);
__exportStar(require("./org.js"), exports);
__exportStar(require("./orgActiveStatus.js"), exports);
__exportStar(require("./orgType.js"), exports);
__exportStar(require("./orgWrite.js"), exports);
__exportStar(require("./orgWritePatch.js"), exports);
__exportStar(require("./person.js"), exports);
__exportStar(require("./personRelation.js"), exports);
__exportStar(require("./personRelationType.js"), exports);
__exportStar(require("./personWrite.js"), exports);
__exportStar(require("./personWritePatch.js"), exports);
__exportStar(require("./preferences.js"), exports);
__exportStar(require("./preferencesPatch.js"), exports);
__exportStar(require("./relation.js"), exports);
__exportStar(require("./relationType.js"), exports);
__exportStar(require("./relationWrite.js"), exports);
__exportStar(require("./relationWritePatch.js"), exports);
__exportStar(require("./role.js"), exports);
__exportStar(require("./roleAssignment.js"), exports);
__exportStar(require("./roleAssignmentWrite.js"), exports);
__exportStar(require("./roleAssignmentWritePatch.js"), exports);
__exportStar(require("./roleScope.js"), exports);
__exportStar(require("./roleWrite.js"), exports);
__exportStar(require("./searchVisibility.js"), exports);
__exportStar(require("./visibilityPreferences.js"), exports);
__exportStar(require("./visibilityPreferencesPatch.js"), exports);
__exportStar(require("./wrappedAffiliation.js"), exports);
__exportStar(require("./wrappedConsent.js"), exports);
__exportStar(require("./wrappedCountry.js"), exports);
__exportStar(require("./wrappedOrg.js"), exports);
__exportStar(require("./wrappedPerson.js"), exports);
__exportStar(require("./wrappedRelation.js"), exports);
__exportStar(require("./wrappedRole.js"), exports);
__exportStar(require("./wrappedRoleAssignment.js"), exports);
__exportStar(require("./wrappedWithMetaArrayAffiliation.js"), exports);
__exportStar(require("./wrappedWithMetaArrayConsent.js"), exports);
__exportStar(require("./wrappedWithMetaArrayCountry.js"), exports);
__exportStar(require("./wrappedWithMetaArrayOrg.js"), exports);
__exportStar(require("./wrappedWithMetaArrayPerson.js"), exports);
__exportStar(require("./wrappedWithMetaArrayRelation.js"), exports);
__exportStar(require("./wrappedWithMetaArrayRole.js"), exports);
__exportStar(require("./wrappedWithMetaArrayRoleAssignment.js"), exports);
const address_js_1 = require("./address.js");
const affiliation_js_1 = require("./affiliation.js");
const affiliationType_js_1 = require("./affiliationType.js");
const affiliationWrite_js_1 = require("./affiliationWrite.js");
const affiliationWritePatch_js_1 = require("./affiliationWritePatch.js");
const consent_js_1 = require("./consent.js");
const consentPurpose_js_1 = require("./consentPurpose.js");
const consentWrite_js_1 = require("./consentWrite.js");
const consentWritePatch_js_1 = require("./consentWritePatch.js");
const country_js_1 = require("./country.js");
const countryWrite_js_1 = require("./countryWrite.js");
const countryWritePatch_js_1 = require("./countryWritePatch.js");
const errorCode_js_1 = require("./errorCode.js");
const errorData_js_1 = require("./errorData.js");
const errorDetails_js_1 = require("./errorDetails.js");
const gender_js_1 = require("./gender.js");
const maritalStatus_js_1 = require("./maritalStatus.js");
const metadata_js_1 = require("./metadata.js");
const nationalId_js_1 = require("./nationalId.js");
const org_js_1 = require("./org.js");
const orgActiveStatus_js_1 = require("./orgActiveStatus.js");
const orgType_js_1 = require("./orgType.js");
const orgWrite_js_1 = require("./orgWrite.js");
const orgWritePatch_js_1 = require("./orgWritePatch.js");
const person_js_1 = require("./person.js");
const personRelation_js_1 = require("./personRelation.js");
const personRelationType_js_1 = require("./personRelationType.js");
const personWrite_js_1 = require("./personWrite.js");
const personWritePatch_js_1 = require("./personWritePatch.js");
const preferences_js_1 = require("./preferences.js");
const preferencesPatch_js_1 = require("./preferencesPatch.js");
const relation_js_1 = require("./relation.js");
const relationType_js_1 = require("./relationType.js");
const relationWrite_js_1 = require("./relationWrite.js");
const relationWritePatch_js_1 = require("./relationWritePatch.js");
const role_js_1 = require("./role.js");
const roleAssignment_js_1 = require("./roleAssignment.js");
const roleAssignmentWrite_js_1 = require("./roleAssignmentWrite.js");
const roleAssignmentWritePatch_js_1 = require("./roleAssignmentWritePatch.js");
const roleScope_js_1 = require("./roleScope.js");
const roleWrite_js_1 = require("./roleWrite.js");
const searchVisibility_js_1 = require("./searchVisibility.js");
const visibilityPreferences_js_1 = require("./visibilityPreferences.js");
const visibilityPreferencesPatch_js_1 = require("./visibilityPreferencesPatch.js");
const wrappedAffiliation_js_1 = require("./wrappedAffiliation.js");
const wrappedConsent_js_1 = require("./wrappedConsent.js");
const wrappedCountry_js_1 = require("./wrappedCountry.js");
const wrappedOrg_js_1 = require("./wrappedOrg.js");
const wrappedPerson_js_1 = require("./wrappedPerson.js");
const wrappedRelation_js_1 = require("./wrappedRelation.js");
const wrappedRole_js_1 = require("./wrappedRole.js");
const wrappedRoleAssignment_js_1 = require("./wrappedRoleAssignment.js");
const wrappedWithMetaArrayAffiliation_js_1 = require("./wrappedWithMetaArrayAffiliation.js");
const wrappedWithMetaArrayConsent_js_1 = require("./wrappedWithMetaArrayConsent.js");
const wrappedWithMetaArrayCountry_js_1 = require("./wrappedWithMetaArrayCountry.js");
const wrappedWithMetaArrayOrg_js_1 = require("./wrappedWithMetaArrayOrg.js");
const wrappedWithMetaArrayPerson_js_1 = require("./wrappedWithMetaArrayPerson.js");
const wrappedWithMetaArrayRelation_js_1 = require("./wrappedWithMetaArrayRelation.js");
const wrappedWithMetaArrayRole_js_1 = require("./wrappedWithMetaArrayRole.js");
const wrappedWithMetaArrayRoleAssignment_js_1 = require("./wrappedWithMetaArrayRoleAssignment.js");
let primitives = [
    "string",
    "boolean",
    "double",
    "integer",
    "long",
    "float",
    "number",
    "any"
];
let enumsMap = {
    "AffiliationType": affiliationType_js_1.AffiliationType,
    "ConsentPurpose": consentPurpose_js_1.ConsentPurpose,
    "ErrorCode": errorCode_js_1.ErrorCode,
    "Gender": gender_js_1.Gender,
    "MaritalStatus": maritalStatus_js_1.MaritalStatus,
    "OrgActiveStatus": orgActiveStatus_js_1.OrgActiveStatus,
    "OrgType": orgType_js_1.OrgType,
    "PersonRelationType": personRelationType_js_1.PersonRelationType,
    "RelationType": relationType_js_1.RelationType,
    "RoleScope": roleScope_js_1.RoleScope,
    "SearchVisibility": searchVisibility_js_1.SearchVisibility,
};
let typeMap = {
    "Address": address_js_1.Address,
    "Affiliation": affiliation_js_1.Affiliation,
    "AffiliationWrite": affiliationWrite_js_1.AffiliationWrite,
    "AffiliationWritePatch": affiliationWritePatch_js_1.AffiliationWritePatch,
    "Consent": consent_js_1.Consent,
    "ConsentWrite": consentWrite_js_1.ConsentWrite,
    "ConsentWritePatch": consentWritePatch_js_1.ConsentWritePatch,
    "Country": country_js_1.Country,
    "CountryWrite": countryWrite_js_1.CountryWrite,
    "CountryWritePatch": countryWritePatch_js_1.CountryWritePatch,
    "ErrorData": errorData_js_1.ErrorData,
    "ErrorDetails": errorDetails_js_1.ErrorDetails,
    "Metadata": metadata_js_1.Metadata,
    "NationalId": nationalId_js_1.NationalId,
    "Org": org_js_1.Org,
    "OrgWrite": orgWrite_js_1.OrgWrite,
    "OrgWritePatch": orgWritePatch_js_1.OrgWritePatch,
    "Person": person_js_1.Person,
    "PersonRelation": personRelation_js_1.PersonRelation,
    "PersonWrite": personWrite_js_1.PersonWrite,
    "PersonWritePatch": personWritePatch_js_1.PersonWritePatch,
    "Preferences": preferences_js_1.Preferences,
    "PreferencesPatch": preferencesPatch_js_1.PreferencesPatch,
    "Relation": relation_js_1.Relation,
    "RelationWrite": relationWrite_js_1.RelationWrite,
    "RelationWritePatch": relationWritePatch_js_1.RelationWritePatch,
    "Role": role_js_1.Role,
    "RoleAssignment": roleAssignment_js_1.RoleAssignment,
    "RoleAssignmentWrite": roleAssignmentWrite_js_1.RoleAssignmentWrite,
    "RoleAssignmentWritePatch": roleAssignmentWritePatch_js_1.RoleAssignmentWritePatch,
    "RoleWrite": roleWrite_js_1.RoleWrite,
    "VisibilityPreferences": visibilityPreferences_js_1.VisibilityPreferences,
    "VisibilityPreferencesPatch": visibilityPreferencesPatch_js_1.VisibilityPreferencesPatch,
    "WrappedAffiliation": wrappedAffiliation_js_1.WrappedAffiliation,
    "WrappedConsent": wrappedConsent_js_1.WrappedConsent,
    "WrappedCountry": wrappedCountry_js_1.WrappedCountry,
    "WrappedOrg": wrappedOrg_js_1.WrappedOrg,
    "WrappedPerson": wrappedPerson_js_1.WrappedPerson,
    "WrappedRelation": wrappedRelation_js_1.WrappedRelation,
    "WrappedRole": wrappedRole_js_1.WrappedRole,
    "WrappedRoleAssignment": wrappedRoleAssignment_js_1.WrappedRoleAssignment,
    "WrappedWithMetaArrayAffiliation": wrappedWithMetaArrayAffiliation_js_1.WrappedWithMetaArrayAffiliation,
    "WrappedWithMetaArrayConsent": wrappedWithMetaArrayConsent_js_1.WrappedWithMetaArrayConsent,
    "WrappedWithMetaArrayCountry": wrappedWithMetaArrayCountry_js_1.WrappedWithMetaArrayCountry,
    "WrappedWithMetaArrayOrg": wrappedWithMetaArrayOrg_js_1.WrappedWithMetaArrayOrg,
    "WrappedWithMetaArrayPerson": wrappedWithMetaArrayPerson_js_1.WrappedWithMetaArrayPerson,
    "WrappedWithMetaArrayRelation": wrappedWithMetaArrayRelation_js_1.WrappedWithMetaArrayRelation,
    "WrappedWithMetaArrayRole": wrappedWithMetaArrayRole_js_1.WrappedWithMetaArrayRole,
    "WrappedWithMetaArrayRoleAssignment": wrappedWithMetaArrayRoleAssignment_js_1.WrappedWithMetaArrayRoleAssignment,
};
class ObjectSerializer {
    static findCorrectType(data, expectedType) {
        if (data == undefined) {
            return expectedType;
        }
        else if (primitives.indexOf(expectedType.toLowerCase()) !== -1) {
            return expectedType;
        }
        else if (expectedType === "Date") {
            return expectedType;
        }
        else {
            if (enumsMap[expectedType]) {
                return expectedType;
            }
            if (!typeMap[expectedType]) {
                return expectedType;
            }
            let discriminatorProperty = typeMap[expectedType].discriminator;
            if (discriminatorProperty == null) {
                return expectedType;
            }
            else {
                if (data[discriminatorProperty]) {
                    var discriminatorType = data[discriminatorProperty];
                    if (typeMap[discriminatorType]) {
                        return discriminatorType;
                    }
                    else {
                        return expectedType;
                    }
                }
                else {
                    return expectedType;
                }
            }
        }
    }
    static serialize(data, type) {
        if (data == undefined) {
            return data;
        }
        else if (primitives.indexOf(type.toLowerCase()) !== -1) {
            return data;
        }
        else if (type.lastIndexOf("Array<", 0) === 0) {
            let subType = type.replace("Array<", "");
            subType = subType.substring(0, subType.length - 1);
            let transformedData = [];
            for (let index = 0; index < data.length; index++) {
                let datum = data[index];
                transformedData.push(ObjectSerializer.serialize(datum, subType));
            }
            return transformedData;
        }
        else if (type === "Date") {
            return data.toISOString();
        }
        else {
            if (enumsMap[type]) {
                return data;
            }
            if (!typeMap[type]) {
                return data;
            }
            type = this.findCorrectType(data, type);
            let attributeTypes = typeMap[type].getAttributeTypeMap();
            let instance = {};
            for (let index = 0; index < attributeTypes.length; index++) {
                let attributeType = attributeTypes[index];
                instance[attributeType.baseName] = ObjectSerializer.serialize(data[attributeType.name], attributeType.type);
            }
            return instance;
        }
    }
    static deserialize(data, type) {
        type = ObjectSerializer.findCorrectType(data, type);
        if (data == undefined) {
            return data;
        }
        else if (primitives.indexOf(type.toLowerCase()) !== -1) {
            return data;
        }
        else if (type.lastIndexOf("Array<", 0) === 0) {
            let subType = type.replace("Array<", "");
            subType = subType.substring(0, subType.length - 1);
            let transformedData = [];
            for (let index = 0; index < data.length; index++) {
                let datum = data[index];
                transformedData.push(ObjectSerializer.deserialize(datum, subType));
            }
            return transformedData;
        }
        else if (type === "Date") {
            return new Date(data);
        }
        else {
            if (enumsMap[type]) {
                return data;
            }
            if (!typeMap[type]) {
                return data;
            }
            let instance = new typeMap[type]();
            let attributeTypes = typeMap[type].getAttributeTypeMap();
            for (let index = 0; index < attributeTypes.length; index++) {
                let attributeType = attributeTypes[index];
                instance[attributeType.name] = ObjectSerializer.deserialize(data[attributeType.baseName], attributeType.type);
            }
            return instance;
        }
    }
}
exports.ObjectSerializer = ObjectSerializer;
class HttpBasicAuth {
    constructor() {
        this.username = '';
        this.password = '';
    }
    applyToRequest(requestOptions) {
        requestOptions.auth = {
            username: this.username, password: this.password
        };
    }
}
exports.HttpBasicAuth = HttpBasicAuth;
class HttpBearerAuth {
    constructor() {
        this.accessToken = '';
    }
    applyToRequest(requestOptions) {
        if (requestOptions && requestOptions.headers) {
            const accessToken = typeof this.accessToken === 'function'
                ? this.accessToken()
                : this.accessToken;
            requestOptions.headers["Authorization"] = "Bearer " + accessToken;
        }
    }
}
exports.HttpBearerAuth = HttpBearerAuth;
class ApiKeyAuth {
    constructor(location, paramName) {
        this.location = location;
        this.paramName = paramName;
        this.apiKey = '';
    }
    applyToRequest(requestOptions) {
        if (this.location == "query") {
            requestOptions.qs[this.paramName] = this.apiKey;
        }
        else if (this.location == "header" && requestOptions && requestOptions.headers) {
            requestOptions.headers[this.paramName] = this.apiKey;
        }
        else if (this.location == 'cookie' && requestOptions && requestOptions.headers) {
            if (requestOptions.headers['Cookie']) {
                requestOptions.headers['Cookie'] += '; ' + this.paramName + '=' + encodeURIComponent(this.apiKey);
            }
            else {
                requestOptions.headers['Cookie'] = this.paramName + '=' + encodeURIComponent(this.apiKey);
            }
        }
    }
}
exports.ApiKeyAuth = ApiKeyAuth;
class OAuth {
    constructor() {
        this.accessToken = '';
    }
    applyToRequest(requestOptions) {
        if (requestOptions && requestOptions.headers) {
            requestOptions.headers["Authorization"] = "Bearer " + this.accessToken;
        }
    }
}
exports.OAuth = OAuth;
class VoidAuth {
    constructor() {
        this.username = '';
        this.password = '';
    }
    applyToRequest(_) {
    }
}
exports.VoidAuth = VoidAuth;
